/*
 * Scilab ( http://www.scilab.org/ ) - This file is part of Scilab
 * Copyright (C) 2010 - DIGITEO - Yann Collette
 * 
 * This file must be used under the terms of the CeCILL.
 * This source file is licensed as described in the file COPYING, which
 * you should have received as part of this distribution.  The terms
 * are also available at    
 * http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
 *
 */
#include <sci_mysql.h>

int sci_mysql_list_fields(char * fname)
{
  int * sql_pointer_in = NULL;
  int * wild = NULL;
  int * table = NULL;
  MYSQL * mysql_ptr = NULL;
  MYSQL_RES * mysql_res_ptr_out = NULL;
  char * cwild = NULL, * ctable = NULL;
  void * ptr_in = NULL;
  SciErr _SciErr;

  CheckRhs(2,3);
  CheckLhs(1,1);

  _SciErr = getVarAddressFromPosition(pvApiCtx, 1, &sql_pointer_in);
  getPointer(pvApiCtx, sql_pointer_in, &ptr_in);
  mysql_ptr = (MYSQL *)ptr_in;

  if (mysql_ptr==NULL)
    {
      Scierror(999,"%s: problem with the mysql pointer\n", fname);
      return 0;
    }

  _SciErr = getVarAddressFromPosition(pvApiCtx, 2, &table);
  getAllocatedSingleString(pvApiCtx, table, &ctable);
  if (Rhs>=3)
    {
      _SciErr = getVarAddressFromPosition(pvApiCtx, 3, &wild);
      getAllocatedSingleString(pvApiCtx, wild, &cwild);
    }
  else
    {
      cwild = NULL;
    }

  mysql_res_ptr_out = mysql_list_fields(mysql_ptr, ctable, cwild);

  if (mysql_res_ptr_out)
    {
      _SciErr = createPointer(pvApiCtx, Rhs+1, (void *)mysql_res_ptr_out);
    }
  else
    {
      createEmptyMatrix(pvApiCtx, Rhs+1);
    }

  LhsVar(1) = Rhs+1;

  if (ctable) freeAllocatedSingleString(ctable);
  if (cwild)  freeAllocatedSingleString(cwild);

  return 0;
}
